Package org.flywaydb.core.api.configuration

## Class FluentConfiguration

- java.lang.Object
- - org.flywaydb.core.api.configuration.FluentConfiguration

- All Implemented Interfaces:
    `Configuration`

      public class FluentConfiguration
      extends java.lang.Object
      implements Configuration

  Fluent configuration for Flyway. This is the preferred means of configuring the Flyway API. This configuration can be passed to Flyway using the `new Flyway(Configuration)` constructor.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FluentConfiguration()` |
    `FluentConfiguration​(java.lang.ClassLoader classLoader)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `FluentConfiguration` | `baselineDescription​(java.lang.String baselineDescription)` | Sets the description to tag an existing schema with when executing baseline.
    `FluentConfiguration` | `baselineOnMigrate​(boolean baselineOnMigrate)` | Whether to automatically call baseline when migrate is executed against a non-empty schema with no schema history table.
    `FluentConfiguration` | `baselineVersion​(java.lang.String baselineVersion)` | Sets the version to tag an existing schema with when executing baseline.
    `FluentConfiguration` | `baselineVersion​(MigrationVersion baselineVersion)` | Sets the version to tag an existing schema with when executing baseline.
    `FluentConfiguration` | `batch​(boolean batch)` | Whether to batch SQL statements when executing them.
    `FluentConfiguration` | `callbacks​(java.lang.String... callbacks)` | Set the callbacks for lifecycle notifications.
    `FluentConfiguration` | `callbacks​(Callback... callbacks)` | Set the callbacks for lifecycle notifications.
    `FluentConfiguration` | `cherryPick​(java.lang.String... cherryPickAsString)` | Gets the migrations that Flyway should consider when migrating or undoing.
    `FluentConfiguration` | `cherryPick​(MigrationPattern... cherryPick)` | Gets the migrations that Flyway should consider when migrating or undoing.
    `FluentConfiguration` | `cleanDisabled​(boolean cleanDisabled)` | Whether to disable clean.
    `FluentConfiguration` | `cleanOnValidationError​(boolean cleanOnValidationError)` | Whether to automatically call clean or not when a validation error occurs.
    `FluentConfiguration` | `configuration​(java.util.Map<java.lang.String,​java.lang.String> props)` | Configures Flyway with these properties.
    `FluentConfiguration` | `configuration​(java.util.Properties properties)` | Configures Flyway with these properties.
    `FluentConfiguration` | `configuration​(Configuration configuration)` | Configure with the same values as this existing configuration.
    `FluentConfiguration` | `connectRetries​(int connectRetries)` | The maximum number of retries when attempting to connect to the database.
    `FluentConfiguration` | `connectRetriesInterval​(int connectRetriesInterval)` | The maximum time between retries when attempting to connect to the database in seconds.
    `FluentConfiguration` | `createSchemas​(boolean createSchemas)` | Whether Flyway should attempt to create the schemas specified in the schemas property
    `FluentConfiguration` | `dataSource​(java.lang.String url, java.lang.String user, java.lang.String password)` | Sets the datasource to use.
    `FluentConfiguration` | `dataSource​(javax.sql.DataSource dataSource)` | Sets the datasource to use.
    `FluentConfiguration` | `defaultSchema​(java.lang.String schema)` | Sets the default schema managed by Flyway.
    `FluentConfiguration` | `detectEncoding​(boolean detectEncoding)` | Whether Flyway should try to automatically detect SQL migration file encoding
    `FluentConfiguration` | `dryRunOutput​(java.io.File dryRunOutput)` | Sets the file where to output the SQL statements of a migration dry run.
    `FluentConfiguration` | `dryRunOutput​(java.io.OutputStream dryRunOutput)` | Sets the stream where to output the SQL statements of a migration dry run.
    `FluentConfiguration` | `dryRunOutput​(java.lang.String dryRunOutputFileName)` | Sets the file where to output the SQL statements of a migration dry run.
    `FluentConfiguration` | `encoding​(java.lang.String encoding)` | Sets the encoding of SQL migrations.
    `FluentConfiguration` | `encoding​(java.nio.charset.Charset encoding)` | Sets the encoding of SQL migrations.
    `FluentConfiguration` | `envVars()` | Configures Flyway using FLYWAY_* environment variables.
    `FluentConfiguration` | `errorOverrides​(java.lang.String... errorOverrides)` | Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.
    `FluentConfiguration` | `executeInTransaction​(boolean executeInTransaction)` | Sets whether SQL should be executed within a transaction.
    `FluentConfiguration` | `failOnMissingLocations​(boolean failOnMissingLocations)` | Whether to fail if a location specified in the flyway.locations option doesn't exist
    `java.lang.String` | `getBaselineDescription()` | Retrieves the description to tag an existing schema with when executing baseline.
    `MigrationVersion` | `getBaselineVersion()` | Retrieves the version to tag an existing schema with when executing baseline.
    `Callback[]` | `getCallbacks()` | Gets the callbacks for lifecycle notifications.
    `MigrationPattern[]` | `getCherryPick()` | Gets the migrations that Flyway should consider when migrating or undoing.
    `java.lang.ClassLoader` | `getClassLoader()` | Retrieves the ClassLoader to use for loading migrations, resolvers, etc.
    `int` | `getConnectRetries()` | The maximum number of retries when attempting to connect to the database.
    `int` | `getConnectRetriesInterval()` | The maximum time between retries when attempting to connect to the database in seconds.
    `javax.sql.DataSource` | `getDataSource()` | Retrieves the dataSource to use to access the database.
    `java.lang.String` | `getDefaultSchema()` | The default schema managed by Flyway.
    `java.io.OutputStream` | `getDryRunOutput()` | The stream where to output the SQL statements of a migration dry run.
    `java.nio.charset.Charset` | `getEncoding()` | Retrieves the encoding of Sql migrations.
    `java.lang.String[]` | `getErrorOverrides()` | Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.
    `ValidatePattern[]` | `getIgnoreMigrationPatterns()` | Ignore migrations that match this comma-separated list of patterns when validating migrations.
    `java.lang.String` | `getInitSql()` | The SQL statements to run to initialize a new database connection immediately after opening it.
    `java.lang.String` | `getInstalledBy()` | The username that will be recorded in the schema history table as having applied the migration.
    `ClassProvider<JavaMigration>` | `getJavaMigrationClassProvider()` | Retrieves the custom ClassProvider to be used to look up `JavaMigration` classes.
    `JavaMigration[]` | `getJavaMigrations()` | The manually added Java-based migrations.
    `java.util.Map<java.lang.String,​java.lang.String>` | `getJdbcProperties()` | Properties to pass to the JDBC driver object Flyway Teams only
    `java.lang.String` | `getKerberosConfigFile()` | The path to the Kerberos config file.
    `java.lang.String` | `getLicenseKey()` | Your Flyway license key (FL01...).
    `Location[]` | `getLocations()` | Retrieves the locations to scan recursively for migrations.
    `int` | `getLockRetryCount()` | The maximum number of retries when trying to obtain a lock.
    `java.lang.String[]` | `getLoggers()` | The loggers Flyway should use.
    `org.flywaydb.core.internal.configuration.models.ConfigurationModel` | `getModernConfig()` |
    `java.lang.String` | `getOracleKerberosCacheFile()` |
    `java.lang.String` | `getOracleWalletLocation()` | The location of your Oracle wallet, used to automatically sign in to your databases.
    `java.lang.String` | `getPassword()` | Retrieves the password used to construct the dataSource.
    `java.lang.String` | `getPlaceholderPrefix()` | Retrieves the prefix of every placeholder.
    `java.util.Map<java.lang.String,​java.lang.String>` | `getPlaceholders()` | Retrieves the map of <placeholder, replacementValue> to apply to sql migration scripts.
    `java.lang.String` | `getPlaceholderSeparator()` | Retrieves the separator of default placeholders.
    `java.lang.String` | `getPlaceholderSuffix()` | Retrieves the suffix of every placeholder.
    `org.flywaydb.core.internal.plugin.PluginRegister` | `getPluginRegister()` |
    `java.lang.String` | `getRepeatableSqlMigrationPrefix()` | Retrieves the file name prefix for repeatable SQL migrations.
    `MigrationResolver[]` | `getResolvers()` | Retrieves the custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
    `ResourceProvider` | `getResourceProvider()` | Retrieves the custom ResourceProvider to be used to look up resources.
    `java.lang.String[]` | `getSchemas()` | The schemas managed by Flyway.
    `java.lang.String` | `getScriptPlaceholderPrefix()` | Retrieves the prefix of every script placeholder.
    `java.lang.String` | `getScriptPlaceholderSuffix()` | Retrieves the suffix of every script placeholder.
    `java.lang.String` | `getSqlMigrationPrefix()` | The file name prefix for versioned SQL migrations.
    `java.lang.String` | `getSqlMigrationSeparator()` | Retrieves the file name separator for sql migrations.
    `java.lang.String[]` | `getSqlMigrationSuffixes()` | The file name suffixes for SQL migrations.
    `java.lang.String` | `getTable()` | Retrieves the name of the schema history table that will be used by Flyway.
    `java.lang.String` | `getTablespace()` | The tablespace where to create the schema history table that will be used by Flyway.
    `MigrationVersion` | `getTarget()` | Gets the target version up to which Flyway should consider migrations.
    `java.lang.String` | `getUndoSqlMigrationPrefix()` | The file name prefix for undo SQL migrations.
    `java.lang.String` | `getUrl()` | Retrieves the url used to construct the dataSource.
    `java.lang.String` | `getUser()` | Retrieves the user used to construct the dataSource.
    `FluentConfiguration` | `group​(boolean group)` | Whether to group all pending migrations together in the same transaction when applying them (only recommended for databases with support for DDL transactions).
    `FluentConfiguration` | `ignoreMigrationPatterns​(java.lang.String... ignoreMigrationPatterns)` | Ignore migrations that match this comma-separated list of patterns when validating migrations.
    `FluentConfiguration` | `ignoreMigrationPatterns​(ValidatePattern... ignoreMigrationPatterns)` | Ignore migrations that match this array of ValidatePatterns when validating migrations.
    `FluentConfiguration` | `initSql​(java.lang.String initSql)` | The SQL statements to run to initialize a new database connection immediately after opening it.
    `FluentConfiguration` | `installedBy​(java.lang.String installedBy)` | The username that will be recorded in the schema history table as having applied the migration.
    `boolean` | `isBaselineOnMigrate()` | Whether to automatically call baseline when migrate is executed against a non-empty schema with no schema history table.
    `boolean` | `isBatch()` | Whether to batch SQL statements when executing them.
    `boolean` | `isCleanDisabled()` | Whether to disable clean.
    `boolean` | `isCleanOnValidationError()` | Whether to automatically call clean or not when a validation error occurs.
    `boolean` | `isCreateSchemas()` | Whether Flyway should attempt to create the schemas specified in the schemas property.
    `boolean` | `isDetectEncoding()` | Whether Flyway should try to automatically detect SQL migration file encoding
    `boolean` | `isExecuteInTransaction()` | Checks whether SQL is executed in a transaction.
    `boolean` | `isFailOnMissingLocations()` | Whether to fail if a location specified in the flyway.locations option doesn't exist
    `boolean` | `isFailOnMissingTarget()` | Whether to fail if no migration with the configured target version exists (default: `true`)
    `boolean` | `isGroup()` | Whether to group all pending migrations together in the same transaction when applying them (only recommended for databases with support for DDL transactions).
    `boolean` | `isMixed()` | Whether to allow mixing transactional and non-transactional statements within the same migration.
    `boolean` | `isOracleSqlplus()` | Whether to Flyway's support for Oracle SQL*Plus commands should be activated.
    `boolean` | `isOracleSqlplusWarn()` | Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statement it doesn't yet support.
    `boolean` | `isOutOfOrder()` | Allows migrations to be run "out of order".
    `boolean` | `isOutputQueryResults()` | Whether Flyway should output a table with the results of queries when executing migrations.
    `boolean` | `isPlaceholderReplacement()` | Checks whether placeholders should be replaced.
    `boolean` | `isSkipDefaultCallbacks()` | Whether Flyway should skip the default callbacks.
    `boolean` | `isSkipDefaultResolvers()` | Whether Flyway should skip the default resolvers.
    `boolean` | `isSkipExecutingMigrations()` | Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table.
    `boolean` | `isStream()` | Whether to stream SQL migrations when executing them.
    `boolean` | `isValidateMigrationNaming()` | Whether to validate migrations and callbacks whose scripts do not obey the correct naming convention.
    `boolean` | `isValidateOnMigrate()` | Whether to automatically call validate or not when running migrate.
    `FluentConfiguration` | `javaMigrationClassProvider​(ClassProvider<JavaMigration> javaMigrationClassProvider)` | Custom ClassProvider to be used to look up `JavaMigration` classes.
    `FluentConfiguration` | `javaMigrations​(JavaMigration... javaMigrations)` | The manually added Java-based migrations.
    `FluentConfiguration` | `jdbcProperties​(java.util.Map<java.lang.String,​java.lang.String> jdbcProperties)` | Properties to pass to the JDBC driver object Flyway Teams only
    `FluentConfiguration` | `kerberosConfigFile​(java.lang.String kerberosConfigFile)` | When connecting to a Kerberos service to authenticate, the path to the Kerberos config file.
    `FluentConfiguration` | `licenseKey​(java.lang.String licenseKey)` | Your Flyway license key (FL01...).
    `Flyway` | `load()` |
    `FluentConfiguration` | `loadDefaultConfigurationFiles()` | Load configuration files from the default locations: $installationDir$/conf/flyway.conf $user.home$/flyway.conf $workingDirectory$/flyway.conf The configuration files must be encoded with UTF-8.
    `FluentConfiguration` | `loadDefaultConfigurationFiles​(java.lang.String encoding)` | Load configuration files from the default locations: $installationDir$/conf/flyway.conf $user.home$/flyway.conf $workingDirectory$/flyway.conf
    `FluentConfiguration` | `locations​(java.lang.String... locations)` | Sets the locations to scan recursively for migrations.
    `FluentConfiguration` | `locations​(Location... locations)` | Sets the locations to scan recursively for migrations.
    `FluentConfiguration` | `lockRetryCount​(int lockRetryCount)` |
    `FluentConfiguration` | `loggers​(java.lang.String... loggers)` | The loggers Flyway should use.
    `FluentConfiguration` | `mixed​(boolean mixed)` | Whether to allow mixing transactional and non-transactional statements within the same migration.
    `FluentConfiguration` | `oracleKerberosCacheFile​(java.lang.String oracleKerberosCacheFile)` | When authenticating to Oracle via Kerberos, the location of the local Kerberos config cache (optional).
    `FluentConfiguration` | `oracleSqlplus​(boolean oracleSqlplus)` | Whether Flyway's support for Oracle SQL*Plus commands should be activated.
    `FluentConfiguration` | `oracleSqlplusWarn​(boolean oracleSqlplusWarn)` | Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statement it doesn't yet support.
    `FluentConfiguration` | `oracleWalletLocation​(java.lang.String oracleWalletLocation)` | The location of your Oracle wallet, used to automatically sign in to your databases.
    `FluentConfiguration` | `outOfOrder​(boolean outOfOrder)` | Allows migrations to be run "out of order".
    `FluentConfiguration` | `outputQueryResults​(boolean outputQueryResults)` | Whether Flyway should output a table with the results of queries when executing migrations.
    `FluentConfiguration` | `placeholderPrefix​(java.lang.String placeholderPrefix)` | Sets the prefix of every placeholder.
    `FluentConfiguration` | `placeholderReplacement​(boolean placeholderReplacement)` | Sets whether placeholders should be replaced.
    `FluentConfiguration` | `placeholders​(java.util.Map<java.lang.String,​java.lang.String> placeholders)` | Sets the placeholders to replace in sql migration scripts.
    `FluentConfiguration` | `placeholderSeparator​(java.lang.String placeholderSeparator)` | Sets the separator of default placeholders.
    `FluentConfiguration` | `placeholderSuffix​(java.lang.String placeholderSuffix)` | Sets the suffix of every placeholder.
    `FluentConfiguration` | `repeatableSqlMigrationPrefix​(java.lang.String repeatableSqlMigrationPrefix)` | Sets the file name prefix for repeatable sql migrations.
    `FluentConfiguration` | `resolvers​(java.lang.String... resolvers)` | Sets custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
    `FluentConfiguration` | `resolvers​(MigrationResolver... resolvers)` | Sets custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
    `FluentConfiguration` | `resourceProvider​(ResourceProvider resourceProvider)` | Custom ResourceProvider to be used to look up resources.
    `FluentConfiguration` | `schemas​(java.lang.String... schemas)` | Sets the schemas managed by Flyway.
    `FluentConfiguration` | `scriptPlaceholderPrefix​(java.lang.String scriptPlaceholderPrefix)` | Sets the prefix of every script placeholder.
    `FluentConfiguration` | `scriptPlaceholderSuffix​(java.lang.String scriptPlaceholderSuffix)` | Sets the suffix of every script placeholder.
    `FluentConfiguration` | `skipDefaultCallbacks​(boolean skipDefaultCallbacks)` | Whether Flyway should skip the default callbacks.
    `FluentConfiguration` | `skipDefaultResolvers​(boolean skipDefaultResolvers)` | Whether Flyway should skip the default resolvers.
    `FluentConfiguration` | `skipExecutingMigrations​(boolean skipExecutingMigrations)` | Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table.
    `FluentConfiguration` | `sqlMigrationPrefix​(java.lang.String sqlMigrationPrefix)` | Sets the file name prefix for sql migrations.
    `FluentConfiguration` | `sqlMigrationSeparator​(java.lang.String sqlMigrationSeparator)` | Sets the file name separator for sql migrations.
    `FluentConfiguration` | `sqlMigrationSuffixes​(java.lang.String... sqlMigrationSuffixes)` | The file name suffixes for SQL migrations.
    `FluentConfiguration` | `stream​(boolean stream)` | Whether to stream SQL migrations when executing them.
    `FluentConfiguration` | `table​(java.lang.String table)` | Sets the name of the schema history table that will be used by Flyway.
    `FluentConfiguration` | `tablespace​(java.lang.String tablespace)` | Sets the tablespace where to create the schema history table that will be used by Flyway.
    `FluentConfiguration` | `target​(java.lang.String target)` | Sets the target version up to which Flyway should consider migrations.
    `FluentConfiguration` | `target​(MigrationVersion target)` | Sets the target version up to which Flyway should consider migrations.
    `FluentConfiguration` | `undoSqlMigrationPrefix​(java.lang.String undoSqlMigrationPrefix)` | Sets the file name prefix for undo SQL migrations.
    `FluentConfiguration` | `validateMigrationNaming​(boolean validateMigrationNaming)` | Whether to validate migrations and callbacks whose scripts do not obey the correct naming convention.
    `FluentConfiguration` | `validateOnMigrate​(boolean validateOnMigrate)` | Whether to automatically call validate or not when running migrate.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FluentConfiguration

          public FluentConfiguration()

    - #### FluentConfiguration

          public FluentConfiguration​(java.lang.ClassLoader classLoader)

      Parameters:
        `classLoader` - The ClassLoader to use for loading migrations, resolvers, etc from the classpath. (default: Thread.currentThread().getContextClassLoader() )

  - ### Method Detail

    - #### load

          public Flyway load()

      Returns:
        The new fully-configured Flyway instance.

    - #### configuration

          public FluentConfiguration configuration​(Configuration configuration)

      Configure with the same values as this existing configuration.

    - #### dryRunOutput

          public FluentConfiguration dryRunOutput​(java.io.OutputStream dryRunOutput)

      Sets the stream where to output the SQL statements of a migration dry run. `null` to execute the SQL statements directly against the database. The stream when be closing when Flyway finishes writing the output. Flyway Teams only
      Parameters:
        `dryRunOutput` - The output file or `null` to execute the SQL statements directly against the database.

    - #### dryRunOutput

          public FluentConfiguration dryRunOutput​(java.io.File dryRunOutput)

      Sets the file where to output the SQL statements of a migration dry run. `null` to execute the SQL statements directly against the database. If the file specified is in a non-existent directory, Flyway will create all directories and parent directories as needed. Flyway Teams only
      Parameters:
        `dryRunOutput` - The output file or `null` to execute the SQL statements directly against the database.

    - #### dryRunOutput

          public FluentConfiguration dryRunOutput​(java.lang.String dryRunOutputFileName)

      Sets the file where to output the SQL statements of a migration dry run. `null` to execute the SQL statements directly against the database. If the file specified is in a non-existent directory, Flyway will create all directories and parent directories as needed. Paths starting with s3: point to a bucket in AWS S3, which must exist. They are in the format s3:(/optionalfolder/subfolder)/filename.sql Paths starting with gcs: point to a bucket in Google Cloud Storage, which must exist. They are in the format gcs:(/optionalfolder/subfolder)/filename.sql Flyway Teams only
      Parameters:
        `dryRunOutputFileName` - The name of the output file or `null` to execute the SQL statements directly against the database.

    - #### errorOverrides

          public FluentConfiguration errorOverrides​(java.lang.String... errorOverrides)

      Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.

      Each error override has the following format: `STATE:12345:W`. It is a 5 character SQL state (or * to match all SQL states), a colon, the SQL error code (or * to match all SQL error codes), a colon and finally the desired behavior that should override the initial one.

      The following behaviors are accepted:

      - `D` to force a debug message
      - `D-` to force a debug message, but do not show the original sql state and error code
      - `I` to force an info message
      - `I-` to force an info message, but do not show the original sql state and error code
      - `W` to force a warning
      - `W-` to force a warning, but do not show the original sql state and error code
      - `E` to force an error
      - `E-` to force an error, but do not show the original sql state and error code

      Example 1: to force Oracle stored procedure compilation issues to produce errors instead of warnings, the following errorOverride can be used: `99999:17110:E`

      Example 2: to force SQL Server PRINT messages to be displayed as info messages (without SQL state and error code details) instead of warnings, the following errorOverride can be used: `S0001:0:I-`

      Example 3: to force all errors with SQL error code 123 to be treated as warnings instead, the following errorOverride can be used: `*:123:W`

      Flyway Teams only
      Parameters:
        `errorOverrides` - The ErrorOverrides or an empty array if none are defined. (default: none)

    - #### group

          public FluentConfiguration group​(boolean group)

      Whether to group all pending migrations together in the same transaction when applying them (only recommended for databases with support for DDL transactions).
      Parameters:
        `group` - `true` if migrations should be grouped. `false` if they should be applied individually instead. (default: `false`)

    - #### installedBy

          public FluentConfiguration installedBy​(java.lang.String installedBy)

      The username that will be recorded in the schema history table as having applied the migration.
      Parameters:
        `installedBy` - The username or `null` for the current database user of the connection. (default: `null`).

    - #### loggers

          public FluentConfiguration loggers​(java.lang.String... loggers)

      The loggers Flyway should use. Valid options are:
      - auto: Auto detect the logger (default behavior)
      - console: Use stdout/stderr (only available when using the CLI)
      - slf4j2: Use the slf4j2 logger
      - log4j2: Use the log4j2 logger
      - apache-commons: Use the Apache Commons logger
      Alternatively you can provide the fully qualified class name for any other logger to use that.

    - #### mixed

          public FluentConfiguration mixed​(boolean mixed)

      Whether to allow mixing transactional and non-transactional statements within the same migration. Enabling this automatically causes the entire affected migration to be run without a transaction. Note that this is only applicable for PostgreSQL, Aurora PostgreSQL, SQL Server and SQLite which all have statements that do not run at all within a transaction. This is not to be confused with implicit transaction, as they occur in MySQL or Oracle, where even though a DDL statement was run within a transaction, the database will issue an implicit commit before and after its execution.
      Parameters:
        `mixed` - `true` if mixed migrations should be allowed. `false` if an error should be thrown instead. (default: `false`)

    - #### ignoreMigrationPatterns

          public FluentConfiguration ignoreMigrationPatterns​(java.lang.String... ignoreMigrationPatterns)

      Ignore migrations that match this comma-separated list of patterns when validating migrations. Each pattern is of the form : See https://flywaydb.org/documentation/configuration/parameters/ignoreMigrationPatterns for full details Example: repeatable:missing,versioned:pending,*:failed Flyway Teams only

    - #### ignoreMigrationPatterns

          public FluentConfiguration ignoreMigrationPatterns​(ValidatePattern... ignoreMigrationPatterns)

      Ignore migrations that match this array of ValidatePatterns when validating migrations. See https://flywaydb.org/documentation/configuration/parameters/ignoreMigrationPatterns for full details Flyway Teams only

    - #### validateMigrationNaming

          public FluentConfiguration validateMigrationNaming​(boolean validateMigrationNaming)

      Whether to validate migrations and callbacks whose scripts do not obey the correct naming convention. A failure can be useful to check that errors such as case sensitivity in migration prefixes have been corrected.
      Parameters:
        `validateMigrationNaming` - `false` to continue normally, `true` to fail fast with an exception. (default: `false`)

    - #### validateOnMigrate

          public FluentConfiguration validateOnMigrate​(boolean validateOnMigrate)

      Whether to automatically call validate or not when running migrate.
      Parameters:
        `validateOnMigrate` - `true` if validate should be called. `false` if not. (default: `true`)

    - #### cleanOnValidationError

          public FluentConfiguration cleanOnValidationError​(boolean cleanOnValidationError)

      Whether to automatically call clean or not when a validation error occurs. This is exclusively intended as a convenience for development. even though we strongly recommend not to change migration scripts once they have been checked into SCM and run, this provides a way of dealing with this case in a smooth manner. The database will be wiped clean automatically, ensuring that the next migration will bring you back to the state checked into SCM. Warning! Do not enable in production!
      Parameters:
        `cleanOnValidationError` - `true` if clean should be called. `false` if not. (default: `false`)

    - #### cleanDisabled

          public FluentConfiguration cleanDisabled​(boolean cleanDisabled)

      Whether to disable clean. This is especially useful for production environments where running clean can be a career limiting move.
      Parameters:
        `cleanDisabled` - `true` to disable clean. `false` to be able to clean. (default: `true`)

    - #### locations

          public FluentConfiguration locations​(java.lang.String... locations)

      Sets the locations to scan recursively for migrations. The location type is determined by its prefix. Unprefixed locations or locations starting with `classpath:` point to a package on the classpath and may contain both SQL and Java-based migrations. Locations starting with `filesystem:` point to a directory on the filesystem, may only contain SQL migrations and are only scanned recursively down non-hidden directories.
      Parameters:
        `locations` - Locations to scan recursively for migrations. (default: db/migration)

    - #### locations

          public FluentConfiguration locations​(Location... locations)

      Sets the locations to scan recursively for migrations. The location type is determined by its prefix. Unprefixed locations or locations starting with `classpath:` point to a package on the classpath and may contain both SQL and Java-based migrations. Locations starting with `filesystem:` point to a directory on the filesystem, may only contain SQL migrations and are only scanned recursively down non-hidden directories.
      Parameters:
        `locations` - Locations to scan recursively for migrations. (default: db/migration)

    - #### encoding

          public FluentConfiguration encoding​(java.lang.String encoding)

      Sets the encoding of SQL migrations.
      Parameters:
        `encoding` - The encoding of SQL migrations. (default: UTF-8)

    - #### encoding

          public FluentConfiguration encoding​(java.nio.charset.Charset encoding)

      Sets the encoding of SQL migrations.
      Parameters:
        `encoding` - The encoding of SQL migrations. (default: UTF-8)

    - #### executeInTransaction

          public FluentConfiguration executeInTransaction​(boolean executeInTransaction)

      Sets whether SQL should be executed within a transaction.
      Parameters:
        `executeInTransaction` - `true` to enable execution of SQL in a transaction, `false` otherwise

    - #### detectEncoding

          public FluentConfiguration detectEncoding​(boolean detectEncoding)

      Whether Flyway should try to automatically detect SQL migration file encoding
      Parameters:
        `detectEncoding` - `true` to enable auto detection, `false` otherwise Flyway Teams only

    - #### defaultSchema

          public FluentConfiguration defaultSchema​(java.lang.String schema)

      Sets the default schema managed by Flyway. This schema name is case-sensitive. If not specified, but schemas is, Flyway uses the first schema in that list. If that is also not specified, Flyway uses the default schema for the database connection.

      Consequences:

      - This schema will be the one containing the schema history table.
      - This schema will be the default for the database connection (provided the database supports this concept).
      Parameters:
        `schema` - The default schema managed by Flyway, which is where the schema history table will reside.

    - #### schemas

          public FluentConfiguration schemas​(java.lang.String... schemas)

      Sets the schemas managed by Flyway. These schema names are case-sensitive. If not specified, Flyway uses the default schema for the database connection. If defaultSchema is not specified, then the first of this list also acts as the default schema.

      Consequences:

      - Flyway will automatically attempt to create all these schemas, unless they already exist.
      - The schemas will be cleaned in the order of this list.
      - If Flyway created them, the schemas themselves will be dropped when cleaning.
      Parameters:
        `schemas` - The schemas managed by Flyway. May not be `null`. Must contain at least one element.

    - #### table

          public FluentConfiguration table​(java.lang.String table)

      Sets the name of the schema history table that will be used by Flyway. By default, (single-schema mode) the schema history table is placed in the default schema for the connection provided by the datasource. When the flyway.schemas property is set (multi-schema mode), the schema history table is placed in the first schema of the list, or in the schema specified to flyway.defaultSchema.
      Parameters:
        `table` - The name of the schema history table that will be used by Flyway. (default: flyway_schema_history)

    - #### tablespace

          public FluentConfiguration tablespace​(java.lang.String tablespace)

      Sets the tablespace where to create the schema history table that will be used by Flyway. If not specified, Flyway uses the default tablespace for the database connection. This setting is only relevant for databases that do support the notion of tablespaces. Its value is simply ignored for all others.
      Parameters:
        `tablespace` - The tablespace where to create the schema history table that will be used by Flyway.

    - #### target

          public FluentConfiguration target​(MigrationVersion target)

      Sets the target version up to which Flyway should consider migrations. Migrations with a higher version number will be ignored. Special values:
      - `current`: Designates the current version of the schema
      - `latest`: The latest version of the schema, as defined by the migration with the highest version
      - `next`: The next version of the schema, as defined by the first pending migration
      Defaults to `latest`.

    - #### target

          public FluentConfiguration target​(java.lang.String target)

      Sets the target version up to which Flyway should consider migrations. Migrations with a higher version number will be ignored. Special values:
      - `current`: Designates the current version of the schema
      - `latest`: The latest version of the schema, as defined by the migration with the highest version
      - <version>? (end with a '?'): Instructs Flyway not to fail if the target version doesn't exist. In this case, Flyway will go up to but not beyond the specified target (default: fail if the target version doesn't exist) Flyway Teams only
      Defaults to `latest`.

    - #### cherryPick

          public FluentConfiguration cherryPick​(MigrationPattern... cherryPick)

      Gets the migrations that Flyway should consider when migrating or undoing. Leave empty to consider all available migrations. Migrations not in this list will be ignored. Flyway Teams only

    - #### cherryPick

          public FluentConfiguration cherryPick​(java.lang.String... cherryPickAsString)

      Gets the migrations that Flyway should consider when migrating or undoing. Leave empty to consider all available migrations. Migrations not in this list will be ignored. Values should be the version for versioned migrations (e.g. 1, 2.4, 6.5.3) or the description for repeatable migrations (e.g. Insert_Data, Create_Table) Flyway Teams only

    - #### placeholderReplacement

          public FluentConfiguration placeholderReplacement​(boolean placeholderReplacement)

      Sets whether placeholders should be replaced.
      Parameters:
        `placeholderReplacement` - Whether placeholders should be replaced. (default: true)

    - #### placeholders

          public FluentConfiguration placeholders​(java.util.Map<java.lang.String,​java.lang.String> placeholders)

      Sets the placeholders to replace in sql migration scripts.
      Parameters:
        `placeholders` - The map of <placeholder, replacementValue> to apply to sql migration scripts.

    - #### placeholderPrefix

          public FluentConfiguration placeholderPrefix​(java.lang.String placeholderPrefix)

      Sets the prefix of every placeholder.
      Parameters:
        `placeholderPrefix` - The prefix of every placeholder. (default: ${ )

    - #### placeholderSuffix

          public FluentConfiguration placeholderSuffix​(java.lang.String placeholderSuffix)

      Sets the suffix of every placeholder.
      Parameters:
        `placeholderSuffix` - The suffix of every placeholder. (default: } )

    - #### placeholderSeparator

          public FluentConfiguration placeholderSeparator​(java.lang.String placeholderSeparator)

      Sets the separator of default placeholders.
      Parameters:
        `placeholderSeparator` - The separator of default placeholders. (default: : )

    - #### scriptPlaceholderPrefix

          public FluentConfiguration scriptPlaceholderPrefix​(java.lang.String scriptPlaceholderPrefix)

      Sets the prefix of every script placeholder.
      Parameters:
        `scriptPlaceholderPrefix` - The prefix of every placeholder. (default: FP__ )

    - #### scriptPlaceholderSuffix

          public FluentConfiguration scriptPlaceholderSuffix​(java.lang.String scriptPlaceholderSuffix)

      Sets the suffix of every script placeholder.
      Parameters:
        `scriptPlaceholderSuffix` - The suffix of every script placeholder. (default: __ )

    - #### sqlMigrationPrefix

          public FluentConfiguration sqlMigrationPrefix​(java.lang.String sqlMigrationPrefix)

      Sets the file name prefix for sql migrations. SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql
      Parameters:
        `sqlMigrationPrefix` - The file name prefix for sql migrations (default: V)

    - #### undoSqlMigrationPrefix

          public FluentConfiguration undoSqlMigrationPrefix​(java.lang.String undoSqlMigrationPrefix)

      Sets the file name prefix for undo SQL migrations. (default: U) Undo SQL migrations are responsible for undoing the effects of the versioned migration with the same version. They have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to U1.1__My_description.sql Flyway Teams only
      Parameters:
        `undoSqlMigrationPrefix` - The file name prefix for undo SQL migrations. (default: U)

    - #### repeatableSqlMigrationPrefix

          public FluentConfiguration repeatableSqlMigrationPrefix​(java.lang.String repeatableSqlMigrationPrefix)

      Sets the file name prefix for repeatable sql migrations. Repeatable SQL migrations have the following file name structure: prefixSeparatorDESCRIPTIONsuffix, which using the defaults translates to R__My_description.sql
      Parameters:
        `repeatableSqlMigrationPrefix` - The file name prefix for repeatable sql migrations (default: R)

    - #### sqlMigrationSeparator

          public FluentConfiguration sqlMigrationSeparator​(java.lang.String sqlMigrationSeparator)

      Sets the file name separator for sql migrations. SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql
      Parameters:
        `sqlMigrationSeparator` - The file name separator for sql migrations (default: __)

    - #### sqlMigrationSuffixes

          public FluentConfiguration sqlMigrationSuffixes​(java.lang.String... sqlMigrationSuffixes)

      The file name suffixes for SQL migrations. (default: .sql) SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql Multiple suffixes (like .sql,.pkg,.pkb) can be specified for easier compatibility with other tools such as editors with specific file associations.
      Parameters:
        `sqlMigrationSuffixes` - The file name suffixes for SQL migrations.

    - #### javaMigrations

          public FluentConfiguration javaMigrations​(JavaMigration... javaMigrations)

      The manually added Java-based migrations. These are not Java-based migrations discovered through classpath scanning and instantiated by Flyway. Instead these are manually added instances of JavaMigration. This is particularly useful when working with a dependency injection container, where you may want the DI container to instantiate the class and wire up its dependencies for you.
      Parameters:
        `javaMigrations` - The manually added Java-based migrations. An empty array if none. (default: none)

    - #### dataSource

          public FluentConfiguration dataSource​(javax.sql.DataSource dataSource)

      Sets the datasource to use. Must have the necessary privileges to execute DDL.
      Parameters:
        `dataSource` - The datasource to use. Must have the necessary privileges to execute DDL.

    - #### dataSource

          public FluentConfiguration dataSource​(java.lang.String url,
                                                java.lang.String user,
                                                java.lang.String password)

      Sets the datasource to use. Must have the necessary privileges to execute DDL.
      Parameters:
        `url` - The JDBC URL of the database.
        `user` - The user of the database.
        `password` - The password of the database.

    - #### connectRetries

          public FluentConfiguration connectRetries​(int connectRetries)

      The maximum number of retries when attempting to connect to the database. After each failed attempt, Flyway will wait 1 second before attempting to connect again, up to the maximum number of times specified by connectRetries. The interval between retries doubles with each subsequent attempt.
      Parameters:
        `connectRetries` - The maximum number of retries (default: 0).

    - #### connectRetriesInterval

          public FluentConfiguration connectRetriesInterval​(int connectRetriesInterval)

      The maximum time between retries when attempting to connect to the database in seconds. This will cap the interval between connect retry to the value provided.
      Parameters:
        `connectRetriesInterval` - The maximum time between retries in seconds (default: 120).

    - #### initSql

          public FluentConfiguration initSql​(java.lang.String initSql)

      The SQL statements to run to initialize a new database connection immediately after opening it.
      Parameters:
        `initSql` - The SQL statements. (default: `null`)

    - #### baselineVersion

          public FluentConfiguration baselineVersion​(MigrationVersion baselineVersion)

      Sets the version to tag an existing schema with when executing baseline.
      Parameters:
        `baselineVersion` - The version to tag an existing schema with when executing baseline. (default: 1)

    - #### baselineVersion

          public FluentConfiguration baselineVersion​(java.lang.String baselineVersion)

      Sets the version to tag an existing schema with when executing baseline.
      Parameters:
        `baselineVersion` - The version to tag an existing schema with when executing baseline. (default: 1)

    - #### baselineDescription

          public FluentConfiguration baselineDescription​(java.lang.String baselineDescription)

      Sets the description to tag an existing schema with when executing baseline.
      Parameters:
        `baselineDescription` - The description to tag an existing schema with when executing baseline. (default: << Flyway Baseline >>)

    - #### baselineOnMigrate

          public FluentConfiguration baselineOnMigrate​(boolean baselineOnMigrate)

      Whether to automatically call baseline when migrate is executed against a non-empty schema with no schema history table. This schema will then be baselined with the `baselineVersion` before executing the migrations. Only migrations above `baselineVersion` will then be applied. This is useful for initial Flyway production deployments on projects with an existing DB. Be careful when enabling this as it removes the safety net that ensures Flyway does not migrate the wrong database in case of a configuration mistake!
      Parameters:
        `baselineOnMigrate` - `true` if baseline should be called on migrate for non-empty schemas, `false` if not. (default: `false`)

    - #### outOfOrder

          public FluentConfiguration outOfOrder​(boolean outOfOrder)

      Allows migrations to be run "out of order". If you already have versions 1 and 3 applied, and now a version 2 is found, it will be applied too instead of being ignored.
      Parameters:
        `outOfOrder` - `true` if outOfOrder migrations should be applied, `false` if not. (default: `false`)

    - #### skipExecutingMigrations

          public FluentConfiguration skipExecutingMigrations​(boolean skipExecutingMigrations)

      Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table. This should be used when you have applied a migration manually (via executing the sql yourself, or via an ide), and just want the schema history table to reflect this. Use in conjunction with `cherryPick` to skip specific migrations instead of all pending ones. Flyway Teams only

    - #### callbacks

          public FluentConfiguration callbacks​(Callback... callbacks)

      Set the callbacks for lifecycle notifications.
      Parameters:
        `callbacks` - The callbacks for lifecycle notifications. (default: none)

    - #### callbacks

          public FluentConfiguration callbacks​(java.lang.String... callbacks)

      Set the callbacks for lifecycle notifications.
      Parameters:
        `callbacks` - The fully qualified class names, or full qualified package to scan, of the callbacks for lifecycle notifications. (default: none)

    - #### skipDefaultCallbacks

          public FluentConfiguration skipDefaultCallbacks​(boolean skipDefaultCallbacks)

      Whether Flyway should skip the default callbacks. If true, only custom callbacks are used.
      Parameters:
        `skipDefaultCallbacks` - Whether default built-in callbacks should be skipped. (default: false)

    - #### resolvers

          public FluentConfiguration resolvers​(MigrationResolver... resolvers)

      Sets custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
      Parameters:
        `resolvers` - The custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply. (default: empty list)

    - #### resolvers

          public FluentConfiguration resolvers​(java.lang.String... resolvers)

      Sets custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
      Parameters:
        `resolvers` - The fully qualified class names of the custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply. (default: empty list)

    - #### skipDefaultResolvers

          public FluentConfiguration skipDefaultResolvers​(boolean skipDefaultResolvers)

      Whether Flyway should skip the default resolvers. If true, only custom resolvers are used.
      Parameters:
        `skipDefaultResolvers` - Whether default built-in resolvers should be skipped. (default: false)

    - #### stream

          public FluentConfiguration stream​(boolean stream)

      Whether to stream SQL migrations when executing them. Streaming doesn't load the entire migration in memory at once. Instead each statement is loaded individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this dramatically reduces Flyway's memory consumption. Flyway Teams only
      Parameters:
        `stream` - `true` to stream SQL migrations. `false` to fully loaded them in memory instead. (default: `false`)

    - #### batch

          public FluentConfiguration batch​(boolean batch)

      Whether to batch SQL statements when executing them. Batching can save up to 99 percent of network roundtrips by sending up to 100 statements at once over the network to the database, instead of sending each statement individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this can dramatically reduce the network overhead. This is supported for INSERT, UPDATE, DELETE, MERGE and UPSERT statements. All other statements are automatically executed without batching. Flyway Teams only
      Parameters:
        `batch` - `true` to batch SQL statements. `false` to execute them individually instead. (default: `false`)

    - #### lockRetryCount

          public FluentConfiguration lockRetryCount​(int lockRetryCount)

    - #### jdbcProperties

          public FluentConfiguration jdbcProperties​(java.util.Map<java.lang.String,​java.lang.String> jdbcProperties)

      Properties to pass to the JDBC driver object Flyway Teams only
      Parameters:
        `jdbcProperties` - The properties to pass to the JDBC driver object

    - #### oracleSqlplus

          public FluentConfiguration oracleSqlplus​(boolean oracleSqlplus)

      Whether Flyway's support for Oracle SQL*Plus commands should be activated. Flyway Teams only
      Parameters:
        `oracleSqlplus` - `true` to active SQL*Plus support. `false` to fail fast instead. (default: `false`)

    - #### oracleSqlplusWarn

          public FluentConfiguration oracleSqlplusWarn​(boolean oracleSqlplusWarn)

      Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statement it doesn't yet support. Flyway Teams only
      Parameters:
        `oracleSqlplusWarn` - `true` to issue a warning. `false` to fail fast instead. (default: `false`)

    - #### kerberosConfigFile

          public FluentConfiguration kerberosConfigFile​(java.lang.String kerberosConfigFile)

      When connecting to a Kerberos service to authenticate, the path to the Kerberos config file. Flyway Teams only
      Parameters:
        `kerberosConfigFile` - The path to the Kerberos config file

    - #### oracleKerberosCacheFile

          public FluentConfiguration oracleKerberosCacheFile​(java.lang.String oracleKerberosCacheFile)

      When authenticating to Oracle via Kerberos, the location of the local Kerberos config cache (optional). Flyway Teams only
      Parameters:
        `oracleKerberosCacheFile` - The Kerberos cache file path.

    - #### oracleWalletLocation

          public FluentConfiguration oracleWalletLocation​(java.lang.String oracleWalletLocation)

      The location of your Oracle wallet, used to automatically sign in to your databases. Flyway Teams only
      Parameters:
        `oracleWalletLocation` - The path to your Oracle Wallet

    - #### licenseKey

          public FluentConfiguration licenseKey​(java.lang.String licenseKey)

      Your Flyway license key (FL01...). Not yet a Flyway Teams Edition customer? Request your Flyway trial license key to try out Flyway Teams Edition features free for 30 days. Flyway Teams only
      Parameters:
        `licenseKey` - Your Flyway license key.

    - #### resourceProvider

          public FluentConfiguration resourceProvider​(ResourceProvider resourceProvider)

      Custom ResourceProvider to be used to look up resources. If not set, the default strategy will be used.
      Parameters:
        `resourceProvider` - Custom ResourceProvider to be used to look up resources

    - #### javaMigrationClassProvider

          public FluentConfiguration javaMigrationClassProvider​(ClassProvider<JavaMigration> javaMigrationClassProvider)

      Custom ClassProvider to be used to look up `JavaMigration` classes. If not set, the default strategy will be used.
      Parameters:
        `javaMigrationClassProvider` - Custom ClassProvider to be used to look up `JavaMigration` classes.

    - #### outputQueryResults

          public FluentConfiguration outputQueryResults​(boolean outputQueryResults)

      Whether Flyway should output a table with the results of queries when executing migrations. Flyway Teams only
      Parameters:
        `outputQueryResults` - `true` to output a table with the results of queries when executing migrations. (default: `true`)

    - #### configuration

          public FluentConfiguration configuration​(java.util.Properties properties)

      Configures Flyway with these properties. This overwrites any existing configuration. Property names are documented in the flyway maven plugin. To use a custom ClassLoader, setClassLoader() must be called prior to calling this method.
      Parameters:
        `properties` - Properties used for configuration.
      Throws:
        `FlywayException` - when the configuration failed.

    - #### configuration

          public FluentConfiguration configuration​(java.util.Map<java.lang.String,​java.lang.String> props)

      Configures Flyway with these properties. This overwrites any existing configuration. Property names are documented in the flyway maven plugin. To use a custom ClassLoader, it must be passed to the Flyway constructor prior to calling this method.
      Parameters:
        `props` - Properties used for configuration.
      Throws:
        `FlywayException` - when the configuration failed.

    - #### loadDefaultConfigurationFiles

          public FluentConfiguration loadDefaultConfigurationFiles()

      Load configuration files from the default locations: $installationDir$/conf/flyway.conf $user.home$/flyway.conf $workingDirectory$/flyway.conf The configuration files must be encoded with UTF-8.
      Throws:
        `FlywayException` - When the configuration failed.

    - #### loadDefaultConfigurationFiles

          public FluentConfiguration loadDefaultConfigurationFiles​(java.lang.String encoding)

      Load configuration files from the default locations: $installationDir$/conf/flyway.conf $user.home$/flyway.conf $workingDirectory$/flyway.conf
      Parameters:
        `encoding` - The conf file encoding.
      Throws:
        `FlywayException` - When the configuration failed.

    - #### createSchemas

          public FluentConfiguration createSchemas​(boolean createSchemas)

      Whether Flyway should attempt to create the schemas specified in the schemas property
      Parameters:
        `createSchemas` -

    - #### envVars

          public FluentConfiguration envVars()

      Configures Flyway using FLYWAY_* environment variables.
      Throws:
        `FlywayException` - When the configuration failed.

    - #### failOnMissingLocations

          public FluentConfiguration failOnMissingLocations​(boolean failOnMissingLocations)

      Whether to fail if a location specified in the flyway.locations option doesn't exist
      Returns:

    - #### getModernConfig

          public org.flywaydb.core.internal.configuration.models.ConfigurationModel getModernConfig()

      Specified by:
        `getModernConfig` in interface `Configuration`

    - #### getClassLoader

          public java.lang.ClassLoader getClassLoader()

      Description copied from interface: `Configuration`
      Retrieves the ClassLoader to use for loading migrations, resolvers, etc. from the classpath.
      Specified by:
        `getClassLoader` in interface `Configuration`
      Returns:
        The ClassLoader to use for loading migrations, resolvers, etc. from the classpath. (default: Thread.currentThread().getContextClassLoader() )

    - #### getPluginRegister

          public org.flywaydb.core.internal.plugin.PluginRegister getPluginRegister()

      Specified by:
        `getPluginRegister` in interface `Configuration`

    - #### getUrl

          public java.lang.String getUrl()

      Description copied from interface: `Configuration`
      Retrieves the url used to construct the dataSource. May be null if the dataSource was passed in directly.
      Specified by:
        `getUrl` in interface `Configuration`
      Returns:
        The url used to construct the dataSource. May be null if the dataSource was passed in directly.

    - #### getUser

          public java.lang.String getUser()

      Description copied from interface: `Configuration`
      Retrieves the user used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a user.
      Specified by:
        `getUser` in interface `Configuration`
      Returns:
        The user used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a user.

    - #### getPassword

          public java.lang.String getPassword()

      Description copied from interface: `Configuration`
      Retrieves the password used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a password.
      Specified by:
        `getPassword` in interface `Configuration`
      Returns:
        The password used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a password.

    - #### getDataSource

          public javax.sql.DataSource getDataSource()

      Description copied from interface: `Configuration`
      Retrieves the dataSource to use to access the database. Must have the necessary privileges to execute DDL.
      Specified by:
        `getDataSource` in interface `Configuration`
      Returns:
        The dataSource to use to access the database. Must have the necessary privileges to execute DDL.

    - #### getConnectRetries

          public int getConnectRetries()

      Description copied from interface: `Configuration`
      The maximum number of retries when attempting to connect to the database. After each failed attempt, Flyway will wait 1 second before attempting to connect again, up to the maximum number of times specified by connectRetries. The interval between retries doubles with each subsequent attempt.
      Specified by:
        `getConnectRetries` in interface `Configuration`
      Returns:
        The maximum number of retries when attempting to connect to the database. (default: 0)

    - #### getConnectRetriesInterval

          public int getConnectRetriesInterval()

      Description copied from interface: `Configuration`
      The maximum time between retries when attempting to connect to the database in seconds. This will cap the interval between connect retry to the value provided.
      Specified by:
        `getConnectRetriesInterval` in interface `Configuration`
      Returns:
        The maximum time between retries in seconds (default: 120)

    - #### getInitSql

          public java.lang.String getInitSql()

      Description copied from interface: `Configuration`
      The SQL statements to run to initialize a new database connection immediately after opening it.
      Specified by:
        `getInitSql` in interface `Configuration`
      Returns:
        The SQL statements. (default: `null`)

    - #### getBaselineVersion

          public MigrationVersion getBaselineVersion()

      Description copied from interface: `Configuration`
      Retrieves the version to tag an existing schema with when executing baseline.
      Specified by:
        `getBaselineVersion` in interface `Configuration`
      Returns:
        The version to tag an existing schema with when executing baseline. (default: 1)

    - #### getBaselineDescription

          public java.lang.String getBaselineDescription()

      Description copied from interface: `Configuration`
      Retrieves the description to tag an existing schema with when executing baseline.
      Specified by:
        `getBaselineDescription` in interface `Configuration`
      Returns:
        The description to tag an existing schema with when executing baseline. (default: << Flyway Baseline >>)

    - #### getResolvers

          public MigrationResolver[] getResolvers()

      Description copied from interface: `Configuration`
      Retrieves the custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
      Specified by:
        `getResolvers` in interface `Configuration`
      Returns:
        The custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply. An empty array if none. (default: none)

    - #### isSkipDefaultResolvers

          public boolean isSkipDefaultResolvers()

      Description copied from interface: `Configuration`
      Whether Flyway should skip the default resolvers. If true, only custom resolvers are used.
      Specified by:
        `isSkipDefaultResolvers` in interface `Configuration`
      Returns:
        Whether default built-in resolvers should be skipped. (default: false)

    - #### getCallbacks

          public Callback[] getCallbacks()

      Description copied from interface: `Configuration`
      Gets the callbacks for lifecycle notifications.
      Specified by:
        `getCallbacks` in interface `Configuration`
      Returns:
        The callbacks for lifecycle notifications. An empty array if none. (default: none)

    - #### isSkipDefaultCallbacks

          public boolean isSkipDefaultCallbacks()

      Description copied from interface: `Configuration`
      Whether Flyway should skip the default callbacks. If true, only custom callbacks are used.
      Specified by:
        `isSkipDefaultCallbacks` in interface `Configuration`
      Returns:
        Whether default built-in callbacks should be skipped. (default: false)

    - #### getSqlMigrationPrefix

          public java.lang.String getSqlMigrationPrefix()

      Description copied from interface: `Configuration`
      The file name prefix for versioned SQL migrations. Versioned SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1.1__My_description.sql
      Specified by:
        `getSqlMigrationPrefix` in interface `Configuration`
      Returns:
        The file name prefix for sql migrations. (default: V)

    - #### getUndoSqlMigrationPrefix

          public java.lang.String getUndoSqlMigrationPrefix()

      Description copied from interface: `Configuration`
      The file name prefix for undo SQL migrations. Undo SQL migrations are responsible for undoing the effects of the versioned migration with the same version. They have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to U1.1__My_description.sql Flyway Teams only
      Specified by:
        `getUndoSqlMigrationPrefix` in interface `Configuration`
      Returns:
        The file name prefix for undo sql migrations. (default: U)

    - #### isExecuteInTransaction

          public boolean isExecuteInTransaction()

      Description copied from interface: `Configuration`
      Checks whether SQL is executed in a transaction.
      Specified by:
        `isExecuteInTransaction` in interface `Configuration`
      Returns:
        Whether SQL is executed in a transaction. (default: true)

    - #### getRepeatableSqlMigrationPrefix

          public java.lang.String getRepeatableSqlMigrationPrefix()

      Description copied from interface: `Configuration`
      Retrieves the file name prefix for repeatable SQL migrations. Repeatable SQL migrations have the following file name structure: prefixSeparatorDESCRIPTIONsuffix, which using the defaults translates to R__My_description.sql<
      Specified by:
        `getRepeatableSqlMigrationPrefix` in interface `Configuration`
      Returns:
        The file name prefix for repeatable sql migrations. (default: R)

    - #### getSqlMigrationSeparator

          public java.lang.String getSqlMigrationSeparator()

      Description copied from interface: `Configuration`
      Retrieves the file name separator for sql migrations. SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql
      Specified by:
        `getSqlMigrationSeparator` in interface `Configuration`
      Returns:
        The file name separator for sql migrations. (default: __)

    - #### getSqlMigrationSuffixes

          public java.lang.String[] getSqlMigrationSuffixes()

      Description copied from interface: `Configuration`
      The file name suffixes for SQL migrations. (default: .sql) SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql Multiple suffixes (like .sql,.pkg,.pkb) can be specified for easier compatibility with other tools such as editors with specific file associations.
      Specified by:
        `getSqlMigrationSuffixes` in interface `Configuration`
      Returns:
        The file name suffixes for SQL migrations.

    - #### getJavaMigrations

          public JavaMigration[] getJavaMigrations()

      Description copied from interface: `Configuration`
      The manually added Java-based migrations. These are not Java-based migrations discovered through classpath scanning and instantiated by Flyway. Instead these are manually added instances of JavaMigration. This is particularly useful when working with a dependency injection container, where you may want the DI container to instantiate the class and wire up its dependencies for you.
      Specified by:
        `getJavaMigrations` in interface `Configuration`
      Returns:
        The manually added Java-based migrations. An empty array if none. (default: none)

    - #### isPlaceholderReplacement

          public boolean isPlaceholderReplacement()

      Description copied from interface: `Configuration`
      Checks whether placeholders should be replaced.
      Specified by:
        `isPlaceholderReplacement` in interface `Configuration`
      Returns:
        Whether placeholders should be replaced. (default: true)

    - #### getPlaceholderSuffix

          public java.lang.String getPlaceholderSuffix()

      Description copied from interface: `Configuration`
      Retrieves the suffix of every placeholder.
      Specified by:
        `getPlaceholderSuffix` in interface `Configuration`
      Returns:
        The suffix of every placeholder. (default: } )

    - #### getPlaceholderPrefix

          public java.lang.String getPlaceholderPrefix()

      Description copied from interface: `Configuration`
      Retrieves the prefix of every placeholder.
      Specified by:
        `getPlaceholderPrefix` in interface `Configuration`
      Returns:
        The prefix of every placeholder. (default: ${ )

    - #### getPlaceholderSeparator

          public java.lang.String getPlaceholderSeparator()

      Description copied from interface: `Configuration`
      Retrieves the separator of default placeholders.
      Specified by:
        `getPlaceholderSeparator` in interface `Configuration`
      Returns:
        The separator of default placeholders. (default: : )

    - #### getScriptPlaceholderSuffix

          public java.lang.String getScriptPlaceholderSuffix()

      Description copied from interface: `Configuration`
      Retrieves the suffix of every script placeholder.
      Specified by:
        `getScriptPlaceholderSuffix` in interface `Configuration`
      Returns:
        The suffix of every script placeholder. (default: __ )

    - #### getScriptPlaceholderPrefix

          public java.lang.String getScriptPlaceholderPrefix()

      Description copied from interface: `Configuration`
      Retrieves the prefix of every script placeholder.
      Specified by:
        `getScriptPlaceholderPrefix` in interface `Configuration`
      Returns:
        The prefix of every script placeholder. (default: FP__ )

    - #### getPlaceholders

          public java.util.Map<java.lang.String,​java.lang.String> getPlaceholders()

      Description copied from interface: `Configuration`
      Retrieves the map of <placeholder, replacementValue> to apply to sql migration scripts.
      Specified by:
        `getPlaceholders` in interface `Configuration`
      Returns:
        The map of <placeholder, replacementValue> to apply to sql migration scripts.

    - #### getTarget

          public MigrationVersion getTarget()

      Description copied from interface: `Configuration`
      Gets the target version up to which Flyway should consider migrations. Migrations with a higher version number will be ignored. Special values:
      - `current`: Designates the current version of the schema
      - `latest`: The latest version of the schema, as defined by the migration with the highest version
      - `next`: The next version of the schema, as defined by the first pending migration
      - <version>? (end with a '?'): Instructs Flyway not to fail if the target version doesn't exist. In this case, Flyway will go up to but not beyond the specified target (default: fail if the target version doesn't exist) Flyway Teams only
      Specified by:
        `getTarget` in interface `Configuration`
      Returns:
        The target version up to which Flyway should consider migrations. Defaults to `latest`

    - #### isFailOnMissingTarget

          public boolean isFailOnMissingTarget()

      Description copied from interface: `Configuration`
      Whether to fail if no migration with the configured target version exists (default: `true`)
      Specified by:
        `isFailOnMissingTarget` in interface `Configuration`

    - #### getCherryPick

          public MigrationPattern[] getCherryPick()

      Description copied from interface: `Configuration`
      Gets the migrations that Flyway should consider when migrating or undoing. Leave empty to consider all available migrations. Migrations not in this list will be ignored. Flyway Teams only
      Specified by:
        `getCherryPick` in interface `Configuration`
      Returns:
        The migrations that Flyway should consider when migrating or undoing.

    - #### getTable

          public java.lang.String getTable()

      Description copied from interface: `Configuration`
      Retrieves the name of the schema history table that will be used by Flyway. By default, (single-schema mode) the schema history table is placed in the default schema for the connection provided by the datasource. When the flyway.schemas property is set (multi-schema mode), the schema history table is placed in the first schema of the list, or in the schema specified to flyway.defaultSchema.
      Specified by:
        `getTable` in interface `Configuration`
      Returns:
        The name of the schema history table that will be used by Flyway. (default: flyway_schema_history)

    - #### getTablespace

          public java.lang.String getTablespace()

      Description copied from interface: `Configuration`
      The tablespace where to create the schema history table that will be used by Flyway. If not specified, Flyway uses the default tablespace for the database connection. This setting is only relevant for databases that do support the notion of tablespace. Its value is simply ignored for all others.
      Specified by:
        `getTablespace` in interface `Configuration`
      Returns:
        The tablespace where to create the schema history table that will be used by Flyway.

    - #### getDefaultSchema

          public java.lang.String getDefaultSchema()

      Description copied from interface: `Configuration`
      The default schema managed by Flyway. This schema name is case-sensitive. If not specified, but schemas is, Flyway uses the first schema in that list. If that is also not specified, Flyway uses the default schema for the database connection.

      Consequences:

      - This schema will be the one containing the schema history table.
      - This schema will be the default for the database connection (provided the database supports this concept).
      Specified by:
        `getDefaultSchema` in interface `Configuration`
      Returns:
        The default schema managed by Flyway, which is where the schema history table will reside. (default: The first schema specified in getSchemas(), and failing that the default schema for the database connection)

    - #### getSchemas

          public java.lang.String[] getSchemas()

      Description copied from interface: `Configuration`
      The schemas managed by Flyway. These schema names are case-sensitive. If not specified, Flyway uses the default schema for the database connection. If defaultSchema is not specified, then the first of this list also acts as the default schema.

      Consequences:

      - Flyway will automatically attempt to create all these schemas, unless they already exist.
      - The schemas will be cleaned in the order of this list.
      - If Flyway created them, the schemas themselves will be dropped when cleaning.
      Specified by:
        `getSchemas` in interface `Configuration`
      Returns:
        The schemas managed by Flyway. (default: The default schema for the database connection)

    - #### getEncoding

          public java.nio.charset.Charset getEncoding()

      Description copied from interface: `Configuration`
      Retrieves the encoding of Sql migrations.
      Specified by:
        `getEncoding` in interface `Configuration`
      Returns:
        The encoding of Sql migrations. (default: UTF-8)

    - #### isDetectEncoding

          public boolean isDetectEncoding()

      Description copied from interface: `Configuration`
      Whether Flyway should try to automatically detect SQL migration file encoding
      Specified by:
        `isDetectEncoding` in interface `Configuration`
      Returns:
        `true` to enable auto detection, `false` otherwise Flyway Teams only

    - #### getLocations

          public Location[] getLocations()

      Description copied from interface: `Configuration`
      Retrieves the locations to scan recursively for migrations. The location type is determined by its prefix. Unprefixed locations or locations starting with `classpath:` point to a package on the classpath and may contain both SQL and Java-based migrations. Locations starting with `filesystem:` point to a directory on the filesystem, may only contain SQL migrations and are only scanned recursively down non-hidden directories.
      Specified by:
        `getLocations` in interface `Configuration`
      Returns:
        Locations to scan recursively for migrations. (default: classpath:db/migration)

    - #### isBaselineOnMigrate

          public boolean isBaselineOnMigrate()

      Description copied from interface: `Configuration`
      Whether to automatically call baseline when migrate is executed against a non-empty schema with no schema history table. This schema will then be initialized with the `baselineVersion` before executing the migrations. Only migrations above `baselineVersion` will then be applied. This is useful for initial Flyway production deployments on projects with an existing DB. Be careful when enabling this as it removes the safety net that ensures Flyway does not migrate the wrong database in case of a configuration mistake!
      Specified by:
        `isBaselineOnMigrate` in interface `Configuration`
      Returns:
        `true` if baseline should be called on migrate for non-empty schemas, `false` if not. (default: `false`)

    - #### isSkipExecutingMigrations

          public boolean isSkipExecutingMigrations()

      Description copied from interface: `Configuration`
      Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table. This should be used when you have applied a migration manually (via executing the sql yourself, or via an ide), and just want the schema history table to reflect this. Use in conjunction with `cherryPick` to skip specific migrations instead of all pending ones. Flyway Teams only
      Specified by:
        `isSkipExecutingMigrations` in interface `Configuration`
      Returns:
        `true` if executing the migrations should be skipped on migrate, `false` if not. (default: `false`)

    - #### isOutOfOrder

          public boolean isOutOfOrder()

      Description copied from interface: `Configuration`
      Allows migrations to be run "out of order". If you already have versions 1 and 3 applied, and now a version 2 is found, it will be applied too instead of being ignored.
      Specified by:
        `isOutOfOrder` in interface `Configuration`
      Returns:
        `true` if outOfOrder migrations should be applied, `false` if not. (default: `false`)

    - #### getIgnoreMigrationPatterns

          public ValidatePattern[] getIgnoreMigrationPatterns()

      Description copied from interface: `Configuration`
      Ignore migrations that match this comma-separated list of patterns when validating migrations. Each pattern is of the form : See https://flywaydb.org/documentation/configuration/parameters/ignoreMigrationPatterns for full details Example: repeatable:missing,versioned:pending,*:failed (default: *:future) Flyway Teams only
      Specified by:
        `getIgnoreMigrationPatterns` in interface `Configuration`

    - #### isValidateMigrationNaming

          public boolean isValidateMigrationNaming()

      Description copied from interface: `Configuration`
      Whether to validate migrations and callbacks whose scripts do not obey the correct naming convention. A failure can be useful to check that errors such as case sensitivity in migration prefixes have been corrected.
      Specified by:
        `isValidateMigrationNaming` in interface `Configuration`
      Returns:
        `false` to continue normally, `true` to fail fast with an exception. (default: `false`)

    - #### isValidateOnMigrate

          public boolean isValidateOnMigrate()

      Description copied from interface: `Configuration`
      Whether to automatically call validate or not when running migrate.
      Specified by:
        `isValidateOnMigrate` in interface `Configuration`
      Returns:
        `true` if validate should be called. `false` if not. (default: `true`)

    - #### isCleanOnValidationError

          public boolean isCleanOnValidationError()

      Description copied from interface: `Configuration`
      Whether to automatically call clean or not when a validation error occurs. This is exclusively intended as a convenience for development. even though we strongly recommend not to change migration scripts once they have been checked into SCM and run, this provides a way of dealing with this case in a smooth manner. The database will be wiped clean automatically, ensuring that the next migration will bring you back to the state checked into SCM. Warning! Do not enable in production!
      Specified by:
        `isCleanOnValidationError` in interface `Configuration`
      Returns:
        `true` if clean should be called. `false` if not. (default: `false`)

    - #### isCleanDisabled

          public boolean isCleanDisabled()

      Description copied from interface: `Configuration`
      Whether to disable clean. This is especially useful for production environments where running clean can be a career limiting move.
      Specified by:
        `isCleanDisabled` in interface `Configuration`
      Returns:
        `true` to disable clean. `false` to be able to clean. (default: `true`)

    - #### isMixed

          public boolean isMixed()

      Description copied from interface: `Configuration`
      Whether to allow mixing transactional and non-transactional statements within the same migration. Enabling this automatically causes the entire affected migration to be run without a transaction. Note that this is only applicable for PostgreSQL, Aurora PostgreSQL, SQL Server and SQLite which all have statements that do not run at all within a transaction. This is not to be confused with implicit transaction, as they occur in MySQL or Oracle, where even though a DDL statement was run within a transaction, the database will issue an implicit commit before and after its execution.
      Specified by:
        `isMixed` in interface `Configuration`
      Returns:
        `true` if mixed migrations should be allowed. `false` if an error should be thrown instead. (default: `false`)

    - #### isGroup

          public boolean isGroup()

      Description copied from interface: `Configuration`
      Whether to group all pending migrations together in the same transaction when applying them (only recommended for databases with support for DDL transactions).
      Specified by:
        `isGroup` in interface `Configuration`
      Returns:
        `true` if migrations should be grouped. `false` if they should be applied individually instead. (default: `false`)

    - #### getInstalledBy

          public java.lang.String getInstalledBy()

      Description copied from interface: `Configuration`
      The username that will be recorded in the schema history table as having applied the migration.
      Specified by:
        `getInstalledBy` in interface `Configuration`
      Returns:
        The username or `null` for the current database user of the connection. (default: `null`).

    - #### getErrorOverrides

          public java.lang.String[] getErrorOverrides()

      Description copied from interface: `Configuration`
      Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.

      Each error override has the following format: `STATE:12345:W`. It is a 5 character SQL state (or * to match all SQL states), a colon, the SQL error code (or * to match all SQL error codes), a colon and finally the desired behavior that should override the initial one.

      The following behaviors are accepted:

      - `D` to force a debug message
      - `D-` to force a debug message, but do not show the original sql state and error code
      - `I` to force an info message
      - `I-` to force an info message, but do not show the original sql state and error code
      - `W` to force a warning
      - `W-` to force a warning, but do not show the original sql state and error code
      - `E` to force an error
      - `E-` to force an error, but do not show the original sql state and error code

      Example 1: to force Oracle stored procedure compilation issues to produce errors instead of warnings, the following errorOverride can be used: `99999:17110:E`

      Example 2: to force SQL Server PRINT messages to be displayed as info messages (without SQL state and error code details) instead of warnings, the following errorOverride can be used: `S0001:0:I-`

      Example 3: to force all errors with SQL error code 123 to be treated as warnings instead, the following errorOverride can be used: `*:123:W`

      Flyway Teams only
      Specified by:
        `getErrorOverrides` in interface `Configuration`
      Returns:
        The ErrorOverrides or an empty array if none are defined. (default: none)

    - #### getDryRunOutput

          public java.io.OutputStream getDryRunOutput()

      Description copied from interface: `Configuration`
      The stream where to output the SQL statements of a migration dry run. `null` if the SQL statements are executed against the database directly. Flyway Teams only
      Specified by:
        `getDryRunOutput` in interface `Configuration`
      Returns:
        The stream or `null` if the SQL statements are executed against the database directly.

    - #### isStream

          public boolean isStream()

      Description copied from interface: `Configuration`
      Whether to stream SQL migrations when executing them. Streaming doesn't load the entire migration in memory at once. Instead each statement is loaded individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this dramatically reduces Flyway's memory consumption. Flyway Teams only
      Specified by:
        `isStream` in interface `Configuration`
      Returns:
        `true` to stream SQL migrations. `false` to fully loaded them in memory instead. (default: `false`)

    - #### isBatch

          public boolean isBatch()

      Description copied from interface: `Configuration`
      Whether to batch SQL statements when executing them. Batching can save up to 99 percent of network roundtrips by sending up to 100 statements at once over the network to the database, instead of sending each statement individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this can dramatically reduce the network overhead. This is supported for INSERT, UPDATE, DELETE, MERGE and UPSERT statements. All other statements are automatically executed without batching. Flyway Teams only
      Specified by:
        `isBatch` in interface `Configuration`
      Returns:
        `true` to batch SQL statements. `false` to execute them individually instead. (default: `false`)

    - #### isOracleSqlplus

          public boolean isOracleSqlplus()

      Description copied from interface: `Configuration`
      Whether to Flyway's support for Oracle SQL*Plus commands should be activated. Flyway Teams only
      Specified by:
        `isOracleSqlplus` in interface `Configuration`
      Returns:
        `true` to active SQL*Plus support. `false` to fail fast instead. (default: `false`)

    - #### isOracleSqlplusWarn

          public boolean isOracleSqlplusWarn()

      Description copied from interface: `Configuration`
      Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statement it doesn't yet support. Flyway Teams only
      Specified by:
        `isOracleSqlplusWarn` in interface `Configuration`
      Returns:
        `true` to issue a warning. `false` to fail fast instead. (default: `false`)

    - #### getKerberosConfigFile

          public java.lang.String getKerberosConfigFile()

      Description copied from interface: `Configuration`
      The path to the Kerberos config file. Flyway Teams only
      Specified by:
        `getKerberosConfigFile` in interface `Configuration`

    - #### getOracleKerberosCacheFile

          public java.lang.String getOracleKerberosCacheFile()

      Specified by:
        `getOracleKerberosCacheFile` in interface `Configuration`

    - #### getLicenseKey

          public java.lang.String getLicenseKey()

      Description copied from interface: `Configuration`
      Your Flyway license key (FL01...). Not yet a Flyway Teams Edition customer? Request your Flyway trial license key to try out Flyway Teams Edition features free for 30 days. Flyway Teams only
      Specified by:
        `getLicenseKey` in interface `Configuration`
      Returns:
        Your Flyway license key.

    - #### isOutputQueryResults

          public boolean isOutputQueryResults()

      Description copied from interface: `Configuration`
      Whether Flyway should output a table with the results of queries when executing migrations. Flyway Teams only
      Specified by:
        `isOutputQueryResults` in interface `Configuration`
      Returns:
        `true` to output the results table (default: `true`)

    - #### getResourceProvider

          public ResourceProvider getResourceProvider()

      Description copied from interface: `Configuration`
      Retrieves the custom ResourceProvider to be used to look up resources. If not set, the default strategy will be used.
      Specified by:
        `getResourceProvider` in interface `Configuration`
      Returns:
        The custom ResourceProvider to be used to look up resources (default: null)

    - #### getJavaMigrationClassProvider

          public ClassProvider<JavaMigration> getJavaMigrationClassProvider()

      Description copied from interface: `Configuration`
      Retrieves the custom ClassProvider to be used to look up `JavaMigration` classes. If not set, the default strategy will be used.
      Specified by:
        `getJavaMigrationClassProvider` in interface `Configuration`
      Returns:
        The custom ClassProvider to be used to look up `JavaMigration` classes (default: null)

    - #### isCreateSchemas

          public boolean isCreateSchemas()

      Description copied from interface: `Configuration`
      Whether Flyway should attempt to create the schemas specified in the schemas property.
      Specified by:
        `isCreateSchemas` in interface `Configuration`
      Returns:

    - #### getLockRetryCount

          public int getLockRetryCount()

      Description copied from interface: `Configuration`
      The maximum number of retries when trying to obtain a lock. -1 indicates attempting to repeat indefinitely.
      Specified by:
        `getLockRetryCount` in interface `Configuration`

    - #### getJdbcProperties

          public java.util.Map<java.lang.String,​java.lang.String> getJdbcProperties()

      Description copied from interface: `Configuration`
      Properties to pass to the JDBC driver object Flyway Teams only
      Specified by:
        `getJdbcProperties` in interface `Configuration`
      Returns:
        Properties that will be passed to the JDBC driver object

    - #### isFailOnMissingLocations

          public boolean isFailOnMissingLocations()

      Description copied from interface: `Configuration`
      Whether to fail if a location specified in the flyway.locations option doesn't exist
      Specified by:
        `isFailOnMissingLocations` in interface `Configuration`
      Returns:

    - #### getOracleWalletLocation

          public java.lang.String getOracleWalletLocation()

      Description copied from interface: `Configuration`
      The location of your Oracle wallet, used to automatically sign in to your databases. Flyway Teams only
      Specified by:
        `getOracleWalletLocation` in interface `Configuration`

    - #### getLoggers

          public java.lang.String[] getLoggers()

      Description copied from interface: `Configuration`
      The loggers Flyway should use. Valid options are:
      - auto: Auto detect the logger (default behavior)
      - console: Use stdout/stderr (only available when using the CLI)
      - slf4j2: Use the slf4j2 logger
      - log4j2: Use the log4j2 logger
      - apache-commons: Use the Apache Commons logger
      Alternatively you can provide the fully qualified class name for any other logger to use that.
      Specified by:
        `getLoggers` in interface `Configuration`